"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _unfetch = _interopRequireDefault(require("unfetch"));

var _factory = _interopRequireDefault(require("./factory"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function URL(url, baseUrl) {
  this.href = baseUrl ? baseUrl + '/' + url : url;
}

function URLSearchParams(obj) {
  var str = '';

  if (typeof obj === 'string') {
    str = obj;
  } else {
    for (var key in obj) {
      str += "".concat(str ? '&' : '').concat(encodeURIComponent(key), "=").concat(encodeURIComponent(obj[key]));
    }
  }

  this._s = str;
}

URLSearchParams.prototype.toString = function () {
  return this._s;
};

function Headers(headers) {
  var _this = this;

  this.__h = {};

  for (var header in headers) {
    this.__h[header.toLowerCase()] = headers[header];
  }

  this.get = function (n) {
    return _this.__h[n.toLowerCase()];
  };

  this.set = function (n, v) {
    return _this.__h[n.toLowerCase()] = v;
  };
}

function fetch(url, options) {
  options.headers = options.headers.__h;
  return (0, _unfetch["default"])(url, options);
}

var _default = (0, _factory["default"])({
  credentials: 'same-origin'
}, {
  fetch: fetch,
  Headers: Headers,
  URL: URL,
  URLSearchParams: URLSearchParams
});

exports["default"] = _default;
module.exports = exports.default;
//# sourceMappingURL=unfetch.js.map